package com.sun.rowset.internal;

import java.io.ObjectInputStream;
import java.sql.SQLException;
import javax.sql.RowSetMetaData;
import java.io.IOException;
import com.sun.rowset.JdbcRowSetResourceBundle;
import java.util.BitSet;
import java.io.Serializable;

public class InsertRow extends BaseRow implements Serializable, Cloneable
{
    private BitSet colsInserted;
    private int cols;
    private JdbcRowSetResourceBundle resBundle;
    static final long serialVersionUID = 1066099658102869344L;
    
    public InsertRow(int n) {
        this.origVals = new Object[n];
        this.colsInserted = new BitSet(n);
        this.cols = n;
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
    }
    
    protected void markColInserted(int bitIndex) {
        this.colsInserted.set(bitIndex);
    }
    
    public boolean isCompleteRow(RowSetMetaData rowSetMetaData) throws SQLException {
        int i = 0;
        while (i < this.cols) {
            if (!this.colsInserted.get(i) && rowSetMetaData.isNullable(i + 1) == 0) {
                return false;
            }
            ++i;
        }
        return true;
    }
    
    public void initInsertRow() {
        for (int i = 0; i < this.cols; ++i) {
            this.colsInserted.clear(i);
        }
    }
    
    @Override
    public Object getColumnObject(int n) throws SQLException {
        if (!this.colsInserted.get(n - 1)) {
            throw new SQLException(this.resBundle.handleGetObject("insertrow.novalue").toString());
        }
        return this.origVals[n - 1];
    }
    
    @Override
    public void setColumnObject(int n, Object o) {
        this.origVals[n - 1] = o;
        this.markColInserted(n - 1);
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException, ClassNotFoundException {
        objectInputStream.defaultReadObject();
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
    }
}
